<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->
<div class="w-100 p-4">

  <app-breadcrumbs></app-breadcrumbs>

  <div
    class="h3"
    [innerText]="editMode ? messages.EDIT_WORKFLOW_TITLE : messages.CREATE_WORKFLOW_TITLE">
  </div>

  <form class="mt-3 w-100" [formGroup]="workflowForm">
    <label
      class="required"
      for="workflowName"
      [innerText]="messages.WORKFLOW_NAME_LABEL">
    </label>
    <div class="d-flex w-50">
      <input
        id="workflowName"
        class="form-control me-2"
        type="text"
        formControlName="name">

      <div class="d-flex">
        <button
          ls-button-save
          [text]="editMode ? messages.SAVE_WORKFLOW : messages.CREATE_WORKFLOW"
          [disabled]="!workflowForm.valid || !allStepsAreValid()"
          (click)="validateWorkflow()">
        </button>

        <button
          ls-button-go-back
          class="ms-2"
          (click)="leaveEditor()">
        </button>
      </div>
    </div>
  </form>

  <div class="w-100 h-100 d-flex flex-row">
    <div class="workflow-editor-container m-2 p-2">
      <ls-workflow-editor
        [(workflow)]="workflowDefinition"
        [(selectedStepEvent)]="selectedStepEvent"
        [options]="options"
        [stepToColorClassFunction]="stepToColorClassFunction"
        [stepToValidationModeIconFunction]="stepToValidationModeIconFunction"
        [stepToActionIconClassFunction]="stepToActionIconClassFunction"
        [stepToTooltipFunction]="stepToTooltipFunction">
      </ls-workflow-editor>
    </div>

    <div class="d-flex w-100 justify-content-center">
      <app-workflow-step-form
        [tenantId]="tenantId"
        [metadataList]="metadataList"
        [(workflowDefinition)]="workflowDefinition"
        [(selectedStepEvent)]="selectedStepEvent">
      </app-workflow-step-form>
    </div>

  </div>

</div>
